//+------------------------------------------------------------------+
//|                                                        rMA_l.mq4 |
//|                                 Copyright  2007, Petr Doroshenko|
//|                                            i7hornet@yahoo.com    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Petr Doroshenko &    "
#property link      "i7hornet@yahoo.com"

#property indicator_separate_window
#property indicator_level1 0

#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 White
//---- input parameters
extern int Price=5; //PRICE_TYPICAL 
extern int Mode=0;//SMA
extern int MPeriod1=3; //5
extern int MPeriod2=15; //21
extern int t3p=8; 
extern int mBar=300;
extern double b=0.7;
extern int trig=20;
//---- buffers
double MainBufferG[0],MainBufferL[0],TBuffUp[0],TBuffDn[0];
//----
double e1,e2,e3,e4,e5,e6,c1,c2,c3,c4,n,w1,w2,b2,b3,dpo,t3,rma;
int i,obar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(4);
//---- indicator lines
   SetIndexBuffer(0, MainBufferG);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,3,Lime);
   SetIndexBuffer(1, MainBufferL); 
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3,Red);
   SetIndexBuffer(2,TBuffUp);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2,White);
   SetIndexBuffer(3,TBuffDn); 
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2,White);   
//---- name for DataWindow and indicator subwindow label
   short_name="R2CMA("+MPeriod1+","+MPeriod2+","+trig+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
//   draw_begin1=MPeriod2;
//   SetIndexDrawBegin(0,draw_begin1);
   
   b2=b*b; 
   b3=b2*b; 
   c1=-b3; 
   c2=(3*(b2+b3)); 
   c3=-3*(2*b2+b+b3); 
   c4=(1+3*b+b3+3*b2); 
   n=t3p;
if(n<1) n=1; 
   n=1+0.5*(n-1); 
   w1=2/(n+1); 
   w2=1-w1;   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
int   counted_bars=IndicatorCounted();     
//---- initial       
//---- check for possible errors
  if (counted_bars<0) return(-1); 
  if (obar!=Bars && obar!=0) {init();return(0);}
//---- 
   for(i=1; i<mBar; i++)
    {
       rma=10000* (iMA(NULL,0, MPeriod1,0,Mode,Price,i)/iMA(NULL,0, MPeriod2,0,Mode,Price,i)-1);
      
       e1=w1*rma+w2*e1; 
       e2=w1*e1+w2*e2; 
       e3=w1*e2+w2*e3; 
       e4=w1*e3+w2*e4; 
       e5=w1*e4+w2*e5; 
       e6=w1*e5+w2*e6;
       t3=c1*e6+c2*e5+c3*e4+c4*e3;    
       
   if (t3>=0){MainBufferG[i-1]=t3; MainBufferL[i-1]=0; TBuffUp[i-1]=trig;}
   if (t3<0) {MainBufferG[i-1]=0; MainBufferL[i-1]=t3; TBuffDn[i-1]=-trig;}

     }  
      obar=Bars;
        
  return(0);
  }
//+------------------------------------------------------------------+