
// dd$: icq 219764

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Crimson
#property indicator_color2 DodgerBlue
#property indicator_color3 Crimson
#property indicator_color4 DodgerBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

extern int RSI_period = 14;
extern string prefix = "RSI-Div";
extern int MaxBars = 300;
extern int dx = 25;
extern int dy = 15;



double UpperFr[];
double LowerFr[];
double UpperFr2[];
double LowerFr2[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  SetIndexBuffer(0, UpperFr);
  SetIndexBuffer(1, LowerFr);
  SetIndexBuffer(2, UpperFr2);
  SetIndexBuffer(3, LowerFr2);
  
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexStyle(1, DRAW_ARROW);
  SetIndexStyle(2, DRAW_ARROW);
  SetIndexStyle(3, DRAW_ARROW);
    
  SetIndexArrow(0, 234);
  SetIndexArrow(1, 233);
  SetIndexArrow(2, 159);
  SetIndexArrow(3, 159);  
  
  clear();
}

void deinit()
{
  clear();
}

void start() 
{

  int shift1 = 40;
  int shift2 = 20;
  
  double fr0, fr1;
  double RSI0, RSI1;
  string obj_name;
  
  
  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  
  if (counted > 0) counted--;
  int limit = Bars-counted;
  limit = MathMin(limit, Bars-dx);
  limit = MathMin(limit, MaxBars);
  
  
  for(int i=3; i < limit+3; i++) 
  {
    //UpperFr[i] = 0;
    
    fr0 = iFractals(NULL, 0, MODE_UPPER, i);
    if (fr0 == 0) continue;
    
    for(int j=i+1; j < i+dx; j++) 
    {
      fr1 = iFractals(NULL, 0, MODE_UPPER, j);
      if (fr1 == 0) continue;
    
      if (fr0 > fr1+dy*Point) 
      {
        RSI0 = iRSI(Symbol(),0,RSI_period,PRICE_CLOSE, i);
        RSI1 = iRSI(Symbol(),0,RSI_period,PRICE_CLOSE, j);
    
        if (RSI0 < RSI1 && RSI0 > 0) 
        {
          bool cond = true;
          for (int k=i; k < j; k++)
          {
            double RSI = iRSI(Symbol(),0,RSI_period,PRICE_CLOSE,k);
            if ((RSI0 > 0 && RSI < 0) || (RSI0 < 0 && RSI > 0))
            {
              cond = false;
              break;
            }
          }
                  
          if (!cond) break;
          
          
          UpperFr[i] = High[i] + (shift1-5)*Point;
          UpperFr2[j] = High[j] + shift2*Point;
          Comment(UpperFr[i]);
          obj_name = prefix+"_tl_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], High[i], Time[j], High[j]);
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color1);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }

  for(i=3; i < limit+3; i++) 
  {
    //LowerFr[i] = 0;
    
    fr0 = iFractals(NULL, 0, MODE_LOWER, i);
    if (fr0 == 0) continue;
    
    for(j=i+1; j < i+dx; j++) 
    {
      fr1 = iFractals(NULL, 0, MODE_LOWER, j);
      if (fr1 == 0) continue;
    
      if (fr0 < fr1-dy*Point) 
      {
        RSI0 = iRSI(Symbol(),0,RSI_period,PRICE_CLOSE,i);
        RSI1 = iRSI(Symbol(),0,RSI_period,PRICE_CLOSE,j);
    
        if (RSI0 > RSI1 && RSI0 < 0) 
        {
          cond = true;
          for (k=i; k < j; k++)
          {
            RSI = iRSI(Symbol(),0,RSI_period,PRICE_CLOSE,k);
            if ((RSI0 > 0 && RSI < 0) || (RSI0 < 0 && RSI > 0))
            {
              cond = false;
              break;
            }
          }
                  
          if (!cond) break;

        
          LowerFr[i] = Low[i] - shift1*Point;
          LowerFr2[j] = Low[j] - shift2*Point;
          
          obj_name = prefix+"_tl_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], Low[i], Time[j], Low[j]);
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color2);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}

