
// dd$: icq 219764

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Crimson
#property indicator_color2 DodgerBlue
#property indicator_color3 Crimson
#property indicator_color4 DodgerBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

extern int Stochastic_Kperiod = 5, Stochastic_Dperiod=3, Stochastic_slowing=3;
extern string prefix = "Stochastic-Div";
extern int MaxBars = 300;
extern int dx = 25;
extern int dy = 15;


double UpperFr[];
double LowerFr[];
double UpperFr2[];
double LowerFr2[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  SetIndexBuffer(0, UpperFr);
  SetIndexBuffer(1, LowerFr);
  SetIndexBuffer(2, UpperFr2);
  SetIndexBuffer(3, LowerFr2);
  
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexStyle(1, DRAW_ARROW);
  SetIndexStyle(2, DRAW_ARROW);
  SetIndexStyle(3, DRAW_ARROW);
    
  SetIndexArrow(0, 234);
  SetIndexArrow(1, 233);
  SetIndexArrow(2, 159);
  SetIndexArrow(3, 159);  
  
  clear();
}

void deinit()
{
  clear();
}

void start() 
{

  int shift1 = 40;
  int shift2 = 20;
  
  double fr0, fr1;
  double Stochastic0, Stochastic1;
  string obj_name;
  
  
  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  
  if (counted > 0) counted--;
  int limit = Bars-counted;
  limit = MathMin(limit, Bars-dx);
  limit = MathMin(limit, MaxBars);
  
  
  for(int i=3; i < limit+3; i++) 
  {
    //UpperFr[i] = 0;
    
    fr0 = iFractals(NULL, 0, MODE_UPPER, i);
    if (fr0 == 0) continue;
    
    for(int j=i+1; j < i+dx; j++) 
    {
      fr1 = iFractals(NULL, 0, MODE_UPPER, j);
      if (fr1 == 0) continue;
    
      if (fr0 > fr1+dy*Point) 
      {
        Stochastic0 = iStochastic(Symbol(),0,Stochastic_Kperiod,Stochastic_Dperiod,Stochastic_slowing,MODE_SMA,0,MODE_MAIN, i);
        Stochastic1 = iStochastic(Symbol(),0,Stochastic_Kperiod,Stochastic_Dperiod,Stochastic_slowing,MODE_SMA,0,MODE_MAIN, j);
    
        if (Stochastic0 < Stochastic1 && Stochastic0 > 50) 
        {
          bool cond = true;
          for (int k=i; k < j; k++)
          {
            double Stochastic = iStochastic(Symbol(),0,Stochastic_Kperiod,Stochastic_Dperiod,Stochastic_slowing,MODE_SMA,0,MODE_MAIN,k);
            if ((Stochastic0 > 50 && Stochastic < 50) || (Stochastic0 < 50 && Stochastic > 50))
            {
              cond = false;
              break;
            }
          }
                  
          if (!cond) break;
          
          
          UpperFr[i] = High[i] + (shift1-5)*Point;
          UpperFr2[j] = High[j] + shift2*Point;
          Comment(UpperFr[i]);
          obj_name = prefix+"_tl_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], High[i], Time[j], High[j]);
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color1);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }

  for(i=3; i < limit+3; i++) 
  {
    //LowerFr[i] = 0;
    
    fr0 = iFractals(NULL, 0, MODE_LOWER, i);
    if (fr0 == 0) continue;
    
    for(j=i+1; j < i+dx; j++) 
    {
      fr1 = iFractals(NULL, 0, MODE_LOWER, j);
      if (fr1 == 0) continue;
    
      if (fr0 < fr1-dy*Point) 
      {
        Stochastic0 = iStochastic(Symbol(),0,Stochastic_Kperiod,Stochastic_Dperiod,Stochastic_slowing,MODE_SMA,0,MODE_MAIN,i);
        Stochastic1 = iStochastic(Symbol(),0,Stochastic_Kperiod,Stochastic_Dperiod,Stochastic_slowing,MODE_SMA,0,MODE_MAIN,j);
    
        if (Stochastic0 > Stochastic1 && Stochastic0 < 50) 
        {
          cond = true;
          for (k=i; k < j; k++)
          {
            Stochastic = iStochastic(Symbol(),0,Stochastic_Kperiod,Stochastic_Dperiod,Stochastic_slowing,MODE_SMA,0,MODE_MAIN,k);
            if ((Stochastic0 > 50 && Stochastic < 50) || (Stochastic0 < 50 && Stochastic > 50))
            {
              cond = false;
              break;
            }
          }
                  
          if (!cond) break;

        
          LowerFr[i] = Low[i] - shift1*Point;
          LowerFr2[j] = Low[j] - shift2*Point;
          
          obj_name = prefix+"_tl_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], Low[i], Time[j], Low[j]);
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color2);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}

