//+------------------------------------------------------------------+
//|                                                    smSA_Trig.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

// : 
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_color4 White
#property stacksize 65535

extern int Range=8;
extern int Shift=3;
extern int OfPoint=0;
extern int Counter=300;
extern int t3_period=8;
extern double b=0.7;
extern double trig=0.5;// TF=M5 && TF=D1 and trig=1.5
double OpenBuf[];
double CloseBuf[];
double TrigUp[],TrigDn[];
double PriceOpen,PriceClose,PriceMax,t3op,t3cl,av,t3av;
double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4, n, w1, w2, b2, b3;
int pr;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3,Lime);
   SetIndexBuffer(0,OpenBuf);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,3,Red);
   SetIndexBuffer(1,CloseBuf);
   SetIndexStyle(2,DRAW_LINE,0,2,White);
   SetIndexBuffer(2,TrigUp);
   SetIndexStyle(3,DRAW_LINE,0,2,White);
   SetIndexBuffer(3,TrigDn);
   IndicatorShortName("smSA_Price");

   b2=b*b;
   b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);
   n=t3_period;

   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;

   if (Point>0.0002) pr=2; else pr=4;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double UpValue=0;
   double UpPrev[5]={0,0,0,0,0};
   double DnValue=0;
   double DnPrev[5]={0,0,0,0,0};
   
   int Rx;
   if (Shift<=0) Shift=1;
   PriceMax=0;
   int    counted_bars=IndicatorCounted();
   if (Counter==0) Counter=Bars;
   
   for (int Ix=Counter-Range;Ix>=0;Ix--)
   {
      PriceOpen=0;
      PriceClose=0;
      for (Rx=Ix;Rx<=Ix+Range;Rx++)
      {
      PriceOpen=PriceOpen+(iOpen(NULL,0,Ix)-iClose(NULL,0,Rx+Shift))/iClose(NULL,0,Rx+Shift)*100;
      PriceClose=PriceClose+(iClose(NULL,0,Ix)-iOpen(NULL,0,Rx+Shift))/iOpen(NULL,0,Rx+Shift)*100;
      }
      e1 = w1*PriceOpen + w2*e1;
      e2 = w1*e1 + w2*e2;
      e3 = w1*e2 + w2*e3;
      e4 = w1*e3 + w2*e4;
      e5 = w1*e4 + w2*e5;
      e6 = w1*e5 + w2*e6;
    t3op = c1*e6 + c2*e5 + c3*e4 + c4*e3;

      
      e1 = w1*PriceClose + w2*e1;
      e2 = w1*e1 + w2*e2;
      e3 = w1*e2 + w2*e3;
      e4 = w1*e3 + w2*e4;
      e5 = w1*e4 + w2*e5;
      e6 = w1*e5 + w2*e6;
    t3cl = c1*e6 + c2*e5 + c3*e4 + c4*e3;  
    
    av= NormalizeDouble(((t3op+t3cl)/2),pr);
      
      e1 = w1*av + w2*e1;
      e2 = w1*e1 + w2*e2;
      e3 = w1*e2 + w2*e3;
      e4 = w1*e3 + w2*e4;
      e5 = w1*e4 + w2*e5;
      e6 = w1*e5 + w2*e6;
    t3av = c1*e6 + c2*e5 + c3*e4 + c4*e3;
    
    if (t3av>=0) {OpenBuf[Ix]=t3av;TrigUp[Ix]=trig;}
    if (t3av<0)  {CloseBuf[Ix]=t3av;TrigDn[Ix]=-trig;}   
      
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+